#!/bin/sh
# Shell script to run the perf programs on different sized data sets.

routine=mul_mfvf_vf

largest=2000

sizes="1"

i=2
# Powers of 2 starting at 2.
while (`test $i -le $largest`)
do
    sizes="$sizes $i"
    i=`expr $i \* 2`
done

i=3
# Powers of 3 starting at 3.
while (`test $i -le $largest`)
do
    sizes="$sizes $i"
    i=`expr $i \* 3`
done

i=10
# Powers of 10 starting at 10
while (`test $i -le $largest`)
do
    sizes="$sizes $i"
    i=`expr $i \* 10`
done

i=13
# Powers of 1.5 starting at 13
while (`test $i -le $largest`)
do
    sizes="$sizes $i"
    i=`expr $i \* 3 / 2`
done        

# sort sizes so results appear in increasing size order.
sizes=`echo $sizes | tr ' ' '\012' | sort +n -`

# Try to do about 1MFLOPs in each inner loop.
flops_per_run=1000000

for n in $sizes
do
    n_flops=`expr $n \* \( 2 \* $n - 1 \)`
    n_inner=`expr $flops_per_run / $n_flops + 1`
    command="${routine}_perf -i $n_inner -o 5 $n"
#    echo $n ' ' $n_flops ' ' $command 1>&2
    $command
done
